/* General parameter definitions for MTsort  */

#ifndef INCegsorth
#define INCegsorth

#define UNI   1
#define MULTI 2

#define TRUE 1
#define FALSE 0

#define event_header_word   0xffff0000

#ifndef INCsortdefns

struct statistics_record *stats;
int current_stream=1;

int **simples;
int **simples_addr;

int **groups;
int **groups_addr;

int *eventstart,*eventptr,*eventend;
void *localdata;

#define INCsortdefns

#endif

int simples_found[16384];

int groups_found[8192];

int *triggers[256];              /* only used by non-eurogam event formats */
int trigger_length[256];         /* only used by non-eurogam event formats */

#include <mtsortstats.h>

#ifndef INCstatdefs
#define INCstatdefs

/* Following are set to point inside above struct by event_init() */

int *blocks_input;
int *blocks_output;
int *events_input;
int *events_output;

#endif

#endif
