

proc :modify_menubutton {win name args} {
  global debug _rows
  set __rows 10

#    options -   :strings ?

  set args [lindex $args 0]
  if {$debug} then {insert-debug ":modify_menubutton called with  $win $name $args"}

  if ([info exists _rows($name)])  {set __rows $_rows($name)}

  set i 0
  while {$i < [llength $args]} {
    set p [lindex $args $i]
    set st [lindex $args [expr $i + 1]]
    switch $p {

      :rows {set __rows $p; set _rows($name) $p}
      :deaf {}
      :inactive  {
        switch $st {
          T {$win configure -state disabled}
          F {$win configure -state normal}
          default {puts stderr ":modify_menubutton  :inactive  - unknown option $v"}
        }
      }
      :label {$win configure -text "$st"}
      :strings  {
        $win.menu delete 0 end
        set ii 0
        set jj 0
        foreach s $st {
          if {$jj == $__rows} then {
             $win.menu add command -label "$s" -columnbreak 1 \
                -command ":menubutton-event $win $name \"$s\" $ii"
             set jj 0
          } else {
             $win.menu add command -label "$s"  \
                -command ":menubutton-event $win $name \"$s\" $ii"
          }
          lappend _$name.menu "$s"
          incr ii
          incr jj
        }
      }
      :menu {
        $win.menu delete 0 end
        set ii 0
        set jj 0
        set kk 0
        foreach s $st {
          if {[llength $s] <= 1} then {
            $win.menu add command -label "$s" \
               -command ":menubutton-event $win $name \"$s\" $kk"
            incr kk
          } else {
            incr ii
            set c [first $s]
            $win.menu add cascade -label "$c" -menu $win.menu.c$ii
            set s [lreplace $s 0 0]
            catch {menu $win.menu.c$ii -tearoff true}
            :_set-font $win.menu.c$ii menu 0 N
            $win.menu.c$ii delete 0 end
            foreach ss $s {
               if {[llength $ss] <= 1} then {
                   $win.menu.c$ii add command -label "$ss" \
                      -command ":menubutton-event $win $name \"$ss\" $kk"
                   incr kk
               } else {
                   incr jj
                   set cc [first $ss]
                   $win.menu.c$ii add cascade -label "$cc" -menu $win.menu.c$ii.c$jj
                   set ss [lreplace $ss 0 0]
                   catch {menu $win.menu.c$ii.c$jj -tearoff true}
                   :_set-font $win.menu.c$ii.c$jj menu 0 N
                   $win.menu.c$ii.c$jj delete 0 end
                   foreach sss $ss {
                      $win.menu.c$ii.c$jj add command -label "$sss" \
                          -command ":menubutton-event $win $name \"$sss\" $kk"
                      incr kk
                   }
               }
            }
         }
       }
      }
      default {puts stderr ":modify_menubutton - unknown arg $p"}
    }
    set i [expr $i + 2]
  }

}
