/*  Eurogam phase 2 Event Builder include file ... "ebstats.h" ... */

struct statistics_record {
  int blocks_input1;                   /* EB   SORT */
  int blocks_input2;                   /*      SORT */
  int blocks_input3;                   /*      SORT */
  int blocks_input4;                   /*      SORT */
  int blocks_output1;                  /* EB   SORT */
  int blocks_output2;                  /* EB   SORT */
  int blocks_output3;                  /* EB   SORT */
  int blocks_output4;                  /* EB   SORT */
  int events_input1;                   /* EB   SORT */
  int events_input2;                   /*      SORT */
  int events_input3;                   /*      SORT */
  int events_input4;                   /*      SORT */
  int events_output1;                  /* EB   SORT */
  int events_output2;                  /* EB   SORT */
  int events_output3;                  /* EB   SORT */
  int events_output4;                  /* EB   SORT */
  int bad_address;                     /* EB        */
  int bad_blockstart;                  /* EB        */
  int repeated_word;                   /* EB        */
  int internal_error;                  /* EB        */
  int no_startevent;                   /* EB        */
  int unexpected_data;                 /* EB        */
  int no_endevent;                     /* EB        */
  int no_endsubevent;                  /* EB        */
  int no_triggerwords;                 /* EB        */
  int roco_eventno_error;              /* EB        */
  int roco_wordcount_error;            /* EB        */
  int roco_flag0_error;                /* EB        */
  int roco_flag1_error;                /* EB        */
  int bad_startevent;                  /* EB        */
  int idleloops;                       /* EB   SORT */
  int number_of_rocos;                 /* EB set by compiler init code */
/* struct defined upto nice round number of 32 ints for compilers */
  int rate;
  int rate_base;
  int rate_compare;
  int rate_alarm;
/* further defined for rate monitoring (see ebexec + statistics register) */
  int bus_errors;
  int invalid_blocks;
  int bad_groupcopy_args;
  int spare1;
  int spare2;
  int spare3;
  int spare4;
  int spare5;
  }; 

struct transfer_statistics_record {
  int blocks_input1;
  int blocks_input2;
  int blocks_input3;
  int blocks_input4;
  int blocks_output1;
  int blocks_output2;
  int blocks_output3;
  int blocks_output4;
  int dma_errors;
  int hardware2;
  int hardware3;
  int hardware4;
  int hardware5;
  int hardware6;
  int hardware7;
  int hardware8;
  }; 

